###################################################
### chunk number 1: 
###################################################
options(prompt = "R> ", np.messages = FALSE, digits = 3, scipen = 3)
library(np)


###################################################
### chunk number 2: 
###################################################
x <- c(-0.57, 0.25, -0.08, 1.40, -1.05, -1.00, 0.37, -1.15, 0.73, 1.59)
x <- sort(x)


###################################################
### chunk number 3: 
###################################################
plot(x,dnorm(x,mean=mean(x),sd=sd(x)),ylab="Density",type="l")


###################################################
### chunk number 4: 
###################################################
hist(x,prob=TRUE)


###################################################
### chunk number 5: 
###################################################
kernel <- function(x,y,h) {
  z <- (x-y)/h
  ifelse(abs(z)<sqrt(5),(1-z^2/5)*(3/(4*sqrt(5))),0)
}

h <- 1

fh1 <- numeric(length(x))

for(i in 1:length(x)) {
  fh1[i] <- sum(kernel(x,x[i],h)/(length(x)*h))
}


###################################################
### chunk number 6: 
###################################################
kernel <- function(x,y,h) {
  z <- (x-y)/h
  ifelse(abs(z)<sqrt(5),(1-z^2/5)*(3/(4*sqrt(5))),0)
}

h <- 0.5

fh05 <- numeric(length(x))

for(i in 1:length(x)) {
  fh05[i] <- sum(kernel(x,x[i],h)/(length(x)*h))
}


###################################################
### chunk number 7: 
###################################################
plot(x,fh05,type="l",ylab="Density",lty=1)
lines(x,fh1,lty=2)
legend(-1,0.2,c("h=0.5","h=1"),lty=c(1,2))


###################################################
### chunk number 8: 
###################################################
data(Italy)
gdp.1998 <- subset(Italy, year==1998)$gdp
bw.rt <- npudensbw(~gdp.1998,bwmethod="normal-reference")
summary(bw.rt)


###################################################
### chunk number 9: 
###################################################
fhat <- npudens(~gdp.1998,bws=bw.rt)
plot(fhat,neval=100,xtrim=-0.75)


###################################################
### chunk number 10: 
###################################################
fhat <- npudens(~gdp.1998,bws=4.1)
plot(fhat,neval=100,xtrim=-0.75)


###################################################
### chunk number 11: 
###################################################
bw.cv <- npudensbw(~gdp.1998,bwmethod="cv.ls")
summary(bw.cv)


###################################################
### chunk number 12: 
###################################################
fhat <- npudens(~gdp.1998,bws=bw.cv)
plot(fhat,neval=100,xtrim=-0.75)


